from vcScript import *
import socket

comp = getComponent()
app = getApplication()
sim = getSimulation()

socketTCP = None
socketState = 0


def OnRun():
  global socketState
  
  cycleTime = 0.01
  delayAfterTransmit = 0.005

  ServerTCP_IP()
      
  while socketState == 1:
    TransmitToTCP()
    delay(delayAfterTransmit)
    
    ReceiveFromTCP()
    delay(cycleTime - delayAfterTransmit)
      
  print 'No connection with TCP/IP client.'  


def ServerTCP_IP(): 
  global socketTCP, socketState
  
  HOST = ''   # Symbolic name, meaning all available interfaces
  portNumber = 2000
  socketState = 0
   
  s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
  s.setblocking(False)
  print 'Socket created'
  delay(0.1)
   
  #Bind socket to local host and port
  try:
      s.bind((HOST, portNumber))
  except socket.error:
      socketState = 2
      print 'Bind failed.'
      return False
       
  print 'Socket bind complete'
  delay(0.1)
   
  #Start listening on socket
  s.listen(5)
  print 'Socket now listening'
  delay(0.1)
  
  #wait to accept a connection - blocking call
  socketTCP, addr = s.accept()
  print 'Connected with ' + addr[0] + ':' + str(addr[1])   
  socketState = 1


def TransmitToTCP():
  global socketTCP

  frame = 'ABC'
         
  try:
    socketTCP.send(frame)

  except socket.error:
    pass


def ReceiveFromTCP():
  global socketTCP
  
  try:
    socketTCP.setblocking(0)
    frameLength = 3
    receivedString = socketTCP.recv(frameLength)
    print receivedString

  except socket.error:
    pass
